#!/bin/bash
set -e

pull() {
  echo "🚛 Pulling $2"
  if [ ! -d "packages/$2" ]; then
    echo "📦 Repository not found, cloning..."
    git clone "https://github.com/$1/$2.git" "packages/$2"
  fi
  (cd "packages/$2" && git config pull.rebase true && git config rebase.autoStash true && git pull)
  echo
}

pull import-js eslint-import-resolver-typescript
pull import-js eslint-plugin-import
pull jsx-eslint eslint-plugin-jsx-a11y
pull eslint-community eslint-plugin-n
pull jsx-eslint eslint-plugin-react
pull jsx-eslint jsx-ast-utils
